diff -Naur --no-dereference a/drivers/gpu/drm/panel/panel-simple.c b/drivers/gpu/drm/panel/panel-simple.c
--- a/drivers/gpu/drm/panel/panel-simple.c	2023-12-20 11:00:29.000000000 -0500
+++ b/drivers/gpu/drm/panel/panel-simple.c	2024-01-28 14:01:31.240353775 -0500
@@ -2486,6 +2486,35 @@
 	.connector_type = DRM_MODE_CONNECTOR_LVDS,
 };
 
+static const struct drm_display_mode lincolntech_lcd185_101ct_mode = {
+	.clock = 155127,
+	.hdisplay = 1920,
+	.hsync_start = 1920 + 128,
+	.hsync_end = 1920 + 128 + 20,
+	.htotal = 1920 + 128 + 20 + 12,
+	.vdisplay = 1200,
+	.vsync_start = 1200 + 19,
+	.vsync_end = 1200 + 19 + 4,
+	.vtotal = 1200 + 19 + 4 + 20,
+};
+
+static const struct panel_desc lincolntech_lcd185_101ct = {
+	.modes = &lincolntech_lcd185_101ct_mode,
+	.bpc = 8,
+	.num_modes = 1,
+	.size = {
+		.width = 217,
+		.height = 136,
+	},
+	.delay = {
+		.prepare = 50,
+		.disable = 50,
+	},
+	.bus_flags = DRM_BUS_FLAG_DE_HIGH,
+	.bus_format = MEDIA_BUS_FMT_RGB888_1X7X4_SPWG,
+	.connector_type = DRM_MODE_CONNECTOR_LVDS,
+};
+
 static const struct display_timing logictechno_lt161010_2nh_timing = {
 	.pixelclock = { 26400000, 33300000, 46800000 },
 	.hactive = { 800, 800, 800 },
@@ -2674,6 +2703,64 @@
 	.bus_flags = DRM_BUS_FLAG_DE_HIGH,
 };
 
+static const struct drm_display_mode microtips_mf_101hiebcaf0_mode = {
+	.clock = 150275,
+	.hdisplay = 1920,
+	.hsync_start = 1920 + 32,
+	.hsync_end = 1920 + 32 + 52,
+	.htotal = 1920 + 32 + 52 + 24,
+	.vdisplay = 1200,
+	.vsync_start = 1200 + 24,
+	.vsync_end = 1200 + 24 + 8,
+	.vtotal = 1200 + 24 + 8 + 3,
+};
+
+static const struct panel_desc microtips_mf_101hiebcaf0 = {
+	.modes = &microtips_mf_101hiebcaf0_mode,
+	.bpc = 8,
+	.num_modes = 1,
+	.size = {
+		.width = 217,
+		.height = 136,
+	},
+	.delay = {
+		.prepare = 50,
+		.disable = 50,
+	},
+	.bus_flags = DRM_BUS_FLAG_DE_HIGH,
+	.bus_format = MEDIA_BUS_FMT_RGB888_1X7X4_SPWG,
+	.connector_type = DRM_MODE_CONNECTOR_LVDS,
+};
+
+static const struct drm_display_mode microtips_mf_103hieb0ga0_mode = {
+	.clock = 93301,
+	.hdisplay = 1920,
+	.hsync_start = 1920 + 72,
+	.hsync_end = 1920 + 72 + 72,
+	.htotal = 1920 + 72 + 72 + 72,
+	.vdisplay = 720,
+	.vsync_start = 720 + 3,
+	.vsync_end = 720 + 3 + 3,
+	.vtotal = 720 + 3 + 3 + 2,
+};
+
+static const struct panel_desc microtips_mf_103hieb0ga0 = {
+	.modes = &microtips_mf_103hieb0ga0_mode,
+	.bpc = 8,
+	.num_modes = 1,
+	.size = {
+		.width = 244,
+		.height = 92,
+	},
+	.delay = {
+		.prepare = 50,
+		.disable = 50,
+	},
+	.bus_flags = DRM_BUS_FLAG_DE_HIGH,
+	.bus_format = MEDIA_BUS_FMT_RGB888_1X7X4_SPWG,
+	.connector_type = DRM_MODE_CONNECTOR_LVDS,
+};
+
 static const struct display_timing multi_inno_mi0700s4t_6_timing = {
 	.pixelclock = { 29000000, 33000000, 38000000 },
 	.hactive = { 800, 800, 800 },
@@ -3193,6 +3280,42 @@
 	.connector_type = DRM_MODE_CONNECTOR_DPI,
 };
 
+static const struct drm_display_mode raspberrypi_7inch_mode = {
+	.clock = 28569600 / 1000,
+	.hdisplay = 800,
+	.hsync_start = 800 + 48, //848
+	.hsync_end = 800 + 48 + 32, //880
+	.htotal = 800 + 48 + 32 + 80, //960
+	.vdisplay = 480,
+	.vsync_start = 480 + 3, //487
+	.vsync_end = 480 + 3 + 7, //450
+	.vtotal = 480 + 3 + 7 + 6, //496
+
+	.crtc_clock = 28569600 / 1000,
+	.crtc_hdisplay = 800,
+	.crtc_hsync_start = 800 + 48, //848
+	.crtc_hsync_end = 800 + 48 + 32, //880
+	.crtc_htotal = 800 + 48 + 32 + 80, //960
+	.crtc_vdisplay = 480,
+	.crtc_vsync_start = 480 + 3, //487
+	.crtc_vsync_end = 480 + 3 + 7, //450
+	.crtc_vtotal = 480 + 3 + 7 + 6, //496
+
+	.flags = DRM_MODE_FLAG_NVSYNC | DRM_MODE_FLAG_NHSYNC,
+};
+
+static const struct panel_desc raspberrypi_7inch = {
+	.modes = &raspberrypi_7inch_mode,
+	.num_modes = 1,
+	.bpc = 8,
+	.size = {
+		.width = 154,
+		.height = 86,
+	},
+	.bus_format = MEDIA_BUS_FMT_RGB888_1X24,
+	.connector_type = DRM_MODE_CONNECTOR_DSI,
+};
+
 static const struct display_timing rocktech_rk070er9427_timing = {
 	.pixelclock = { 26400000, 33300000, 46800000 },
 	.hactive = { 800, 800, 800 },
@@ -4143,6 +4266,9 @@
 		.compatible = "lg,lb070wv8",
 		.data = &lg_lb070wv8,
 	}, {
+		.compatible = "lincolntech,lcd185-101ct",
+		.data = &lincolntech_lcd185_101ct,
+	}, {
 		.compatible = "logicpd,type28",
 		.data = &logicpd_type_28,
 	}, {
@@ -4161,6 +4287,12 @@
 		.compatible = "logictechno,lttd800480070-l6wh-rt",
 		.data = &logictechno_lttd800480070_l6wh_rt,
 	}, {
+		.compatible = "microtips,mf-101hiebcaf0",
+		.data = &microtips_mf_101hiebcaf0,
+	}, {
+		.compatible = "microtips,mf-103hieb0ga0",
+		.data = &microtips_mf_103hieb0ga0,
+	}, {
 		.compatible = "mitsubishi,aa070mc01-ca1",
 		.data = &mitsubishi_aa070mc01,
 	}, {
@@ -4224,6 +4356,9 @@
 		.compatible = "qishenglong,gopher2b-lcd",
 		.data = &qishenglong_gopher2b_lcd,
 	}, {
+		.compatible = "raspberrypi,7inch-dsi",
+		.data = &raspberrypi_7inch,
+	}, {
 		.compatible = "rocktech,rk070er9427",
 		.data = &rocktech_rk070er9427,
 	}, {
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_crtc.c b/drivers/gpu/drm/tidss/tidss_crtc.c
--- a/drivers/gpu/drm/tidss/tidss_crtc.c	2023-12-20 11:00:29.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_crtc.c	2024-01-28 14:01:31.240353775 -0500
@@ -34,11 +34,17 @@
 	 * the same time. This happens before the vertical blank interrupt.
 	 * So there is a small change that the driver sets GO bit after VFP, but
 	 * before vblank, and we have to check for that case here.
+	 *
+	 * For a video port shared between Linux and remote core but owned by remote core,
+	 * this is not required since Linux just attaches to mode that was preset by remote
+	 * core with which display is being shared.
 	 */
-	busy = dispc_vp_go_busy(tidss->dispc, tcrtc->hw_videoport);
-	if (busy) {
-		spin_unlock_irqrestore(&ddev->event_lock, flags);
-		return;
+	if (!tidss->shared_mode || tidss->shared_mode_owned_vps[tcrtc->vp_idx]) {
+		busy = dispc_vp_go_busy(tidss->dispc, tcrtc->vp_idx);
+		if (busy) {
+			spin_unlock_irqrestore(&ddev->event_lock, flags);
+			return;
+		}
 	}
 
 	event = tcrtc->event;
@@ -77,7 +83,7 @@
 	struct tidss_crtc *tcrtc = to_tidss_crtc(crtc);
 
 	dev_err_ratelimited(crtc->dev->dev, "CRTC%u SYNC LOST: (irq %llx)\n",
-			    tcrtc->hw_videoport, irqstatus);
+			    tcrtc->vp_idx, irqstatus);
 }
 
 /* drm_crtc_helper_funcs */
@@ -91,7 +97,7 @@
 	struct tidss_device *tidss = to_tidss(ddev);
 	struct dispc_device *dispc = tidss->dispc;
 	struct tidss_crtc *tcrtc = to_tidss_crtc(crtc);
-	u32 hw_videoport = tcrtc->hw_videoport;
+	u32 vp_idx = tcrtc->vp_idx;
 	const struct drm_display_mode *mode;
 	enum drm_mode_status ok;
 
@@ -102,14 +108,14 @@
 
 	mode = &crtc_state->adjusted_mode;
 
-	ok = dispc_vp_mode_valid(dispc, hw_videoport, mode);
+	ok = dispc_vp_mode_valid(dispc, vp_idx, mode);
 	if (ok != MODE_OK) {
 		dev_dbg(ddev->dev, "%s: bad mode: %ux%u pclk %u kHz\n",
 			__func__, mode->hdisplay, mode->vdisplay, mode->clock);
 		return -EINVAL;
 	}
 
-	return dispc_vp_bus_check(dispc, hw_videoport, crtc_state);
+	return dispc_vp_bus_check(dispc, vp_idx, crtc_state);
 }
 
 /*
@@ -151,11 +157,11 @@
 			struct tidss_plane *tplane = to_tidss_plane(plane);
 
 			dispc_ovr_set_plane(tidss->dispc, tplane->hw_plane_id,
-					    tcrtc->hw_videoport,
+					    tcrtc->vp_idx,
 					    pstate->crtc_x, pstate->crtc_y,
 					    layer);
 		}
-		dispc_ovr_enable_layer(tidss->dispc, tcrtc->hw_videoport, layer,
+		dispc_ovr_enable_layer(tidss->dispc, tcrtc->vp_idx, layer,
 				       layer_active);
 	}
 }
@@ -170,14 +176,10 @@
 	struct tidss_device *tidss = to_tidss(ddev);
 	unsigned long flags;
 
-	dev_dbg(ddev->dev,
-		"%s: %s enabled %d, needs modeset %d, event %p\n", __func__,
-		crtc->name, drm_atomic_crtc_needs_modeset(crtc->state),
-		crtc->state->enable, crtc->state->event);
-
-	/* There is nothing to do if CRTC is not going to be enabled. */
-	if (!crtc->state->enable)
-		return;
+	dev_dbg(ddev->dev, "%s: %s is %sactive, %s modeset, event %p\n",
+		__func__, crtc->name, crtc->state->active ? "" : "not ",
+		drm_atomic_crtc_needs_modeset(crtc->state) ? "needs" : "doesn't need",
+		crtc->state->event);
 
 	/*
 	 * Flush CRTC changes with go bit only if new modeset is not
@@ -187,7 +189,7 @@
 		return;
 
 	/* If the GO bit is stuck we better quit here. */
-	if (WARN_ON(dispc_vp_go_busy(tidss->dispc, tcrtc->hw_videoport)))
+	if (WARN_ON(dispc_vp_go_busy(tidss->dispc, tcrtc->vp_idx)))
 		return;
 
 	/* We should have event if CRTC is enabled through out this commit. */
@@ -195,7 +197,7 @@
 		return;
 
 	/* Write vp properties to HW if needed. */
-	dispc_vp_setup(tidss->dispc, tcrtc->hw_videoport, crtc->state, false);
+	dispc_vp_setup(tidss->dispc, tcrtc->vp_idx, crtc->state, false);
 
 	/* Update plane positions if needed. */
 	tidss_crtc_position_planes(tidss, crtc, old_crtc_state, false);
@@ -203,7 +205,45 @@
 	WARN_ON(drm_crtc_vblank_get(crtc) != 0);
 
 	spin_lock_irqsave(&ddev->event_lock, flags);
-	dispc_vp_go(tidss->dispc, tcrtc->hw_videoport);
+	dispc_vp_go(tidss->dispc, tcrtc->vp_idx);
+
+	WARN_ON(tcrtc->event);
+
+	tcrtc->event = crtc->state->event;
+	crtc->state->event = NULL;
+
+	spin_unlock_irqrestore(&ddev->event_lock, flags);
+}
+
+static void tidss_shared_vp_crtc_atomic_flush(struct drm_crtc *crtc,
+					      struct drm_atomic_state *state)
+{
+	struct tidss_crtc *tcrtc = to_tidss_crtc(crtc);
+	struct drm_device *ddev = crtc->dev;
+	unsigned long flags;
+
+	dev_dbg(ddev->dev,
+		"%s: %s enabled %d, needs modeset %d, event %p\n", __func__,
+		crtc->name, drm_atomic_crtc_needs_modeset(crtc->state),
+		crtc->state->enable, crtc->state->event);
+
+	/* There is nothing to do if CRTC is not going to be enabled. */
+	if (!crtc->state->enable)
+		return;
+	/*
+	 * Flush CRTC changes with go bit only if new modeset is not
+	 * coming, so CRTC is enabled trough out the commit.
+	 */
+	if (drm_atomic_crtc_needs_modeset(crtc->state))
+		return;
+
+	/* We should have event if CRTC is enabled through out this commit. */
+	if (WARN_ON(!crtc->state->event))
+		return;
+
+	WARN_ON(drm_crtc_vblank_get(crtc) != 0);
+
+	spin_lock_irqsave(&ddev->event_lock, flags);
 
 	WARN_ON(tcrtc->event);
 
@@ -229,24 +269,45 @@
 
 	tidss_runtime_get(tidss);
 
-	r = dispc_vp_set_clk_rate(tidss->dispc, tcrtc->hw_videoport,
+	r = dispc_vp_set_clk_rate(tidss->dispc, tcrtc->vp_idx,
 				  mode->clock * 1000);
 	if (r != 0)
 		return;
 
-	r = dispc_vp_enable_clk(tidss->dispc, tcrtc->hw_videoport);
+	r = dispc_vp_enable_clk(tidss->dispc, tcrtc->vp_idx);
 	if (r != 0)
 		return;
 
-	dispc_vp_setup(tidss->dispc, tcrtc->hw_videoport, crtc->state, true);
+	dispc_vp_setup(tidss->dispc, tcrtc->vp_idx, crtc->state, true);
 	tidss_crtc_position_planes(tidss, crtc, old_state, true);
 
 	/* Turn vertical blanking interrupt reporting on. */
 	drm_crtc_vblank_on(crtc);
 
-	dispc_vp_prepare(tidss->dispc, tcrtc->hw_videoport, crtc->state);
+	dispc_vp_prepare(tidss->dispc, tcrtc->vp_idx, crtc->state);
 
-	dispc_vp_enable(tidss->dispc, tcrtc->hw_videoport, crtc->state);
+	dispc_vp_enable(tidss->dispc, tcrtc->vp_idx, crtc->state);
+
+	spin_lock_irqsave(&ddev->event_lock, flags);
+
+	if (crtc->state->event) {
+		drm_crtc_send_vblank_event(crtc, crtc->state->event);
+		crtc->state->event = NULL;
+	}
+
+	spin_unlock_irqrestore(&ddev->event_lock, flags);
+}
+
+static void tidss_shared_vp_crtc_atomic_enable(struct drm_crtc *crtc,
+					       struct drm_atomic_state *state)
+{
+	struct drm_device *ddev = crtc->dev;
+	unsigned long flags;
+
+	dev_dbg(ddev->dev, "%s, event %p\n", __func__, crtc->state->event);
+
+	/* Turn vertical blanking interrupt reporting on. */
+	drm_crtc_vblank_on(crtc);
 
 	spin_lock_irqsave(&ddev->event_lock, flags);
 
@@ -270,14 +331,14 @@
 
 	reinit_completion(&tcrtc->framedone_completion);
 
-	dispc_vp_disable(tidss->dispc, tcrtc->hw_videoport);
+	dispc_vp_disable(tidss->dispc, tcrtc->vp_idx);
 
 	if (!wait_for_completion_timeout(&tcrtc->framedone_completion,
 					 msecs_to_jiffies(500)))
 		dev_err(tidss->dev, "Timeout waiting for framedone on crtc %d",
-			tcrtc->hw_videoport);
+			tcrtc->vp_idx);
 
-	dispc_vp_unprepare(tidss->dispc, tcrtc->hw_videoport);
+	dispc_vp_unprepare(tidss->dispc, tcrtc->vp_idx);
 
 	spin_lock_irqsave(&ddev->event_lock, flags);
 	if (crtc->state->event) {
@@ -288,11 +349,32 @@
 
 	drm_crtc_vblank_off(crtc);
 
-	dispc_vp_disable_clk(tidss->dispc, tcrtc->hw_videoport);
+	dispc_vp_disable_clk(tidss->dispc, tcrtc->vp_idx);
 
 	tidss_runtime_put(tidss);
 }
 
+static void tidss_shared_vp_crtc_atomic_disable(struct drm_crtc *crtc,
+						struct drm_atomic_state *state)
+{
+	struct tidss_crtc *tcrtc = to_tidss_crtc(crtc);
+	struct drm_device *ddev = crtc->dev;
+	unsigned long flags;
+
+	dev_dbg(ddev->dev, "%s, event %p\n", __func__, crtc->state->event);
+
+	reinit_completion(&tcrtc->framedone_completion);
+
+	spin_lock_irqsave(&ddev->event_lock, flags);
+	if (crtc->state->event) {
+		drm_crtc_send_vblank_event(crtc, crtc->state->event);
+		crtc->state->event = NULL;
+	}
+	spin_unlock_irqrestore(&ddev->event_lock, flags);
+
+	drm_crtc_vblank_off(crtc);
+}
+
 static
 enum drm_mode_status tidss_crtc_mode_valid(struct drm_crtc *crtc,
 					   const struct drm_display_mode *mode)
@@ -301,7 +383,7 @@
 	struct drm_device *ddev = crtc->dev;
 	struct tidss_device *tidss = to_tidss(ddev);
 
-	return dispc_vp_mode_valid(tidss->dispc, tcrtc->hw_videoport, mode);
+	return dispc_vp_mode_valid(tidss->dispc, tcrtc->vp_idx, mode);
 }
 
 static const struct drm_crtc_helper_funcs tidss_crtc_helper_funcs = {
@@ -309,7 +391,14 @@
 	.atomic_flush = tidss_crtc_atomic_flush,
 	.atomic_enable = tidss_crtc_atomic_enable,
 	.atomic_disable = tidss_crtc_atomic_disable,
+	.mode_valid = tidss_crtc_mode_valid,
+};
 
+static const struct drm_crtc_helper_funcs tidss_shared_vp_crtc_helper_funcs = {
+	.atomic_check = tidss_crtc_atomic_check,
+	.atomic_flush = tidss_shared_vp_crtc_atomic_flush,
+	.atomic_enable = tidss_shared_vp_crtc_atomic_enable,
+	.atomic_disable = tidss_shared_vp_crtc_atomic_disable,
 	.mode_valid = tidss_crtc_mode_valid,
 };
 
@@ -402,7 +491,7 @@
 };
 
 struct tidss_crtc *tidss_crtc_create(struct tidss_device *tidss,
-				     u32 hw_videoport,
+				     u32 vp_idx,
 				     struct drm_plane *primary)
 {
 	struct tidss_crtc *tcrtc;
@@ -411,11 +500,13 @@
 	bool has_ctm = tidss->feat->vp_feat.color.has_ctm;
 	int ret;
 
+	dev_dbg(tidss->dev, "%s: tidss->shared_mode: %d tidss->shared_mode_owned_vps[%d] = %d\n",
+		__func__, tidss->shared_mode, vp_idx, tidss->shared_mode_owned_vps[vp_idx]);
 	tcrtc = kzalloc(sizeof(*tcrtc), GFP_KERNEL);
 	if (!tcrtc)
 		return ERR_PTR(-ENOMEM);
 
-	tcrtc->hw_videoport = hw_videoport;
+	tcrtc->vp_idx = vp_idx;
 	init_completion(&tcrtc->framedone_completion);
 
 	crtc =  &tcrtc->crtc;
@@ -427,8 +518,16 @@
 		return ERR_PTR(ret);
 	}
 
-	drm_crtc_helper_add(crtc, &tidss_crtc_helper_funcs);
-
+	/* Use shared video port CRTC helpers which don't access associated
+	 * video port and overlay register spaces when Linux is not owning the
+	 * video port.
+	 */
+	if (tidss->shared_mode && !tidss->shared_mode_owned_vps[vp_idx]) {
+		drm_crtc_helper_add(crtc, &tidss_shared_vp_crtc_helper_funcs);
+		dev_dbg(tidss->dev, "%s: vp%d is being shared with Linux\n", __func__, vp_idx + 1);
+	} else {
+		drm_crtc_helper_add(crtc, &tidss_crtc_helper_funcs);
+	}
 	/*
 	 * The dispc gamma functions adapt to what ever size we ask
 	 * from it no matter what HW supports. X-server assumes 256
diff -Naur --no-dereference a/drivers/gpu/drm/tidss/tidss_crtc.h b/drivers/gpu/drm/tidss/tidss_crtc.h
--- a/drivers/gpu/drm/tidss/tidss_crtc.h	2023-12-20 11:00:29.000000000 -0500
+++ b/drivers/gpu/drm/tidss/tidss_crtc.h	2024-01-28 14:01:31.240353775 -0500
@@ -19,7 +19,7 @@
 struct tidss_crtc {
 	struct drm_crtc crtc;
 
-	u32 hw_videoport;
+	u32 vp_idx;
 
 	struct drm_pending_vblank_event *event;
 
@@ -43,6 +43,5 @@
 void tidss_crtc_error_irq(struct drm_crtc *crtc, u64 irqstatus);
 
 struct tidss_crtc *tidss_crtc_create(struct tidss_device *tidss,
-				     u32 hw_videoport,
-				     struct drm_plane *primary);
+				     u32 vp_idx, struct drm_plane *primary);
 #endif
